﻿--
-- self
-- for all self
--
-- @author by landwirtschaftssimulator-2009.de
-- @date  08/06/09
--
-- Copyright (C) 

Tatra = {};

function Tatra.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function Tatra:load(savegame)
    self.handBrakeHud = Overlay:new("hBOverlay", Utils.getFilename("Textury/hb_symbol.dds", self.baseDirectory), 0.785, 0.250, 0.040, 0.050);
    self.twinVL = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.twinVL#index"));
    self.twinVR = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.twinVR#index"));
    self.twinHL = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.twinHL#index"));
    self.twinHR = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.twinHR#index"));    
      
    self.numWorklights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.worklights#count"), 0);
    self.worklights = {};
    for i=1, self.numWorklights do
        local worklightnamei = string.format("vehicle.worklights.worklight" .. "%d", i);
        self.worklights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, worklightnamei .. "#index"));
        setVisibility(self.worklights[i], false);
    end;    
    
    self.numbrakelights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.brakelights#count"), 0);
    self.brakelights = {};
    for i=1, self.numbrakelights do
        local brakelightnamei = string.format("vehicle.brakelights.brakelight" .. "%d", i);
        self.brakelights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, brakelightnamei .. "#index"));
        setVisibility(self.brakelights[i], false);
    end;
    self.brakelightsActive = false;
    self.braking = false;
    
    local brakeSound = getXMLString(xmlFile, "vehicle.brakeSound#file");
    if brakeSound ~= nil and brakeSound ~= "" then
    brakeSound = Utils.getFilename(brakeSound, self.baseDirectory);
        self.brakeSound = createSample("brakeSound");
        loadSample(self.brakeSound, brakeSound, false);
    end;
    
    local handbrakeSound = getXMLString(xmlFile, "vehicle.handbrakeSound#file");
    if handbrakeSound ~= nil and handbrakeSound ~= "" then
    handbrakeSound = Utils.getFilename(handbrakeSound, self.baseDirectory);
        self.handbrakeSound = createSample("handbrakeSound");
        loadSample(self.handbrakeSound, handbrakeSound, false);
    end;
    local handbrakeReleaseSound = getXMLString(xmlFile, "vehicle.handbrakeReleaseSound#file");
    if handbrakeReleaseSound ~= nil and handbrakeReleaseSound ~= "" then
    handbrakeReleaseSound = Utils.getFilename(handbrakeReleaseSound, self.baseDirectory);
        self.handbrakeReleaseSound = createSample("handbrakeReleaseSound");
        loadSample(self.handbrakeReleaseSound, handbrakeReleaseSound, false);
    end;
    
    local compressorSound = getXMLString(xmlFile, "vehicle.compressorSound#file");
    if compressorSound ~= nil and compressorSound ~= "" then
    compressorSound = Utils.getFilename(compressorSound, self.baseDirectory);
        self.compressorSound = createSample("compressorSound");
        loadSample(self.compressorSound, compressorSound, false);
    end;
    
    local compressorStopSound = getXMLString(xmlFile, "vehicle.compressorStopSound#file");
    if compressorStopSound ~= nil and compressorStopSound ~= "" then
    compressorStopSound = Utils.getFilename(compressorStopSound, self.baseDirectory);
        self.compressorStopSound = createSample("compressorStopSound");
        loadSample(self.compressorStopSound, compressorStopSound, false);
    end;
    local motorMaxRpmStr = getXMLString(xmlFile, "vehicle.motor#maxRpm");
    local motorMaxRpm1, motorMaxRpm2, motorMaxRpm3 = Utils.getVectorFromString(motorMaxRpmStr);
    motorMaxRpm1 = Utils.getNoNil(motorMaxRpm1, 800);
    motorMaxRpm2 = Utils.getNoNil(motorMaxRpm2, 1000);
    motorMaxRpm3 = Utils.getNoNil(motorMaxRpm3, 1500);
    local motorMaxRpm = {motorMaxRpm1, motorMaxRpm2, motorMaxRpm3};
    self.motorMaxRpmLimit = motorMaxRpm;    
    self.lightsbrake = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.extra_lights.brake#index"));
    self.lightshandbrake = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.extra_lights.handbrake#index"));
    self.handbrakeSoundRunning = false;
    self.handbrakeReleaseSoundRunning = false;
    self.brakeForce = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.brakeForce"), 5);
    self.Tlak = 9500;
    self.farlightsActive = false;
    self.frontlightsActive = false;
    self.worklightsActive = false;
    self.zuendungKey = true;
    self.allowedZuendung = true; 
    self.compressorStart = false;
    self.brakeSoundRunning = true;
    self.rotationMaxbackwindow = false;
    self.compressor = true;
    self.handbrake = true;
end;

function Tatra:keyEvent(unicode, sym, modifier, isDown)

    if isDown and sym == Input.KEY_space and self.spec_HB == nil then
        self.handbrake = not self.handbrake;
    end;
end;


function Tatra:update(dt)
    if self.isMotorStarted then 
        self.compressor = true;
    else
        self.compressor = false;
    end;
        
    if self.isHired or self.drive then
        self.handbrake = false;
    end;
    
    if self.isMotorStarted and self:getIsActiveForInput() and self.isEntered and not (self.isHired or self.drive) then
    
        if self.motor.speedLevel ~= 0 then
            
            if Input.keyPressedState[119] then 
                if self.motor.maxRpm[self.motor.speedLevel] <= (self.motorMaxRpmLimit[3] - 10) then
                    self.motor.maxRpm[self.motor.speedLevel] = self.motor.maxRpm[self.motor.speedLevel] + 10;
                end;
            elseif Input.keyPressedState[115] then
                if self.motor.maxRpm[self.motor.speedLevel] >= 10 then
                    self.motor.maxRpm[self.motor.speedLevel] = self.motor.maxRpm[self.motor.speedLevel] - 10;
                end;
            end;
                
        else
            if Input.keyPressedState[119] then
                if self.motor.maxRpm[3] <= (self.motorMaxRpmLimit[3] - 10) then
                    self.motor.maxRpm[3] = self.motor.maxRpm[3] + 10;
                end;
            elseif Input.keyPressedState[115] then
                if self.motor.maxRpm[3] >= 10 then
                        self.motor.maxRpm[3] = self.motor.maxRpm[3] - 10;
                end;
            end;
        end;
        
    end;
  if self.compressor then 
      if self.Tlak >= -1 and self.Tlak <= 6000 then
            self.compressorStart = true;
        end;
        if self.Tlak >= 9999 then
            self.compressorStart = false;
        end;
        if self.compressorStart == true then
            if not self.compressorSoundRunning then
                playSample(self.compressorSound, 0, 1, 0);
                self.compressorSoundRunning = true;
            end;
            self.compressorStopSoundRunning = false;
            if self.Tlak <= 10000 then
                self.Tlak = self.Tlak +(dt/3);
            end;
        end;
        if self.compressorStart == false then
            stopSample(self.compressorSound, 0, 1, 0);
            self.compressorSoundRunning = false;
            if not self.compressorStopSoundRunning then
                playSample(self.compressorStopSound, 1, 1, 0);
                self.compressorStopSoundRunning = true;
            end;

        end;
      
        inputAxisY = InputBinding.getAnalogInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE);
        if InputBinding.isAxisZero(inputAxisY) then
            inputAxisY = InputBinding.getDigitalInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE);
        end;        
        
        if (self.movingDirection*self.lastSpeed*(-inputAxisY)) < -0.001 then
            setVisibility(self.lightsbrake, true);
            if self.Tlak >= 5500 then
                self.motor.brakeForce = self.motorBrakeForce;
                if not self.brakeSoundRunning then
                    playSample(self.brakeSound, 1, 1, 0);
                    self.brakeSoundRunning = true;
                end;
            end;
            if not self.braking then
                if self.Tlak > 0 then
                    self.Tlak = self.Tlak -350;
                end;
                self.braking = true;
            end;
        else
            if not self.handbrake and not (self.isHired or self.drive) then
                self.motor.brakeForce = 0;
            end;
                setVisibility(self.lightsbrake, false);
            self.braking = false;
            if self.Tlak >= 5500 then
        
                    self.brakeSoundRunning = false;
            end;
        end;

        if self.handbrake then
            brakeTorque = 10000;
            self.motor.brakeForce = brakeTorque;
            self.braking = true;
            setVisibility(self.lightshandbrake, self.handbrake);

            if not self.handbrakeSoundRunning then
                playSample(self.handbrakeSound, 1, 1, 0);
                self.handbrakeSoundRunning = true;
            end;
            self.handbrakeReleaseSoundRunning = false;
        else
            self.motor.brakeForce = self.brakeForce;
            if not self.handbrakeReleaseSoundRunning and not self.handbrake then
                playSample(self.handbrakeReleaseSound, 1, 1, 0);
                self.handbrakeReleaseSoundRunning = true;
            end;
            setVisibility(self.lightshandbrake, false);
            self.handbrakeSoundRunning = false;
        end;
 end;
end;

function Tatra:draw()

    if self.handbrake and self.spec_HB == nil and not (self.isHired or self.drive) then
        setTextBold(true);
        setTextColor(1,0,0,1);
        inputAxisY = InputBinding.getAnalogInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE);
        if InputBinding.isAxisZero(inputAxisY) then
            inputAxisY = InputBinding.getDigitalInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE);
        end;        
        if (self.movingDirection*self.lastSpeed*(-inputAxisY))  then
            setTextBold(true);
            setTextColor(1,0,0,1);
            if self.isServer then
                for k,wheel in pairs(self.wheels) do
                    setWheelShapeProps(wheel.node, wheel.wheelShape, 0, 999, 0);
                end;
            end;            
        end;
        self.handBrakeHud:render();
        setTextColor(1,1,1,1);
    end;
end;

function Tatra:onEnter()
    self.compressorStopSoundRunning = true;
    Utils.setEmittingState(self.exhaustParticleLow, false);
end;

function Tatra:onLeave()
    if not (self.isHired or self.drive) then
        self.handbrake = true;
        self:stopAITractor();
        if not self.isMotorStarted then
            self.compressor = false;
        end;
    end;
     stopSample(self.compressorSound);
     self.compressorSoundRunning = false;
end;

function Tatra:delete()
    Utils.deleteParticleSystem(self.exhaustParticleLow);
    Utils.deleteParticleSystem(self.exhaustParticleHigh);
    stopSample(self.compressorSound);
    delete(self.radioSound)
    print("Tatra 813 8x8 unloaded");
end;


function Tatra:mouseEvent(posX, posY, isDown, isUp, button)
end;