﻿--
-- self
-- for all self
--
-- @author by landwirtschaftssimulator-2009.de
-- @date  08/06/09
--
-- Copyright (C) 

Tatra = {};

function Tatra.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function Tatra:load(savegame)
    self.handBrakeHud = Overlay:new("hBOverlay", Utils.getFilename("texturas/hb_symbol.dds", self.baseDirectory), 0.785, 0.250, 0.040, 0.050);
    self.twinVL = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.twinVL#index"));
    self.twinVR = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.twinVR#index"));
    self.twinHL = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.twinHL#index"));
    self.twinHR = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.twinHR#index"));    
      
    self.numWorklights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.worklights#count"), 0);
    self.worklights = {};
    for i=1, self.numWorklights do
        local worklightnamei = string.format("vehicle.worklights.worklight" .. "%d", i);
        self.worklights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, worklightnamei .. "#index"));
        setVisibility(self.worklights[i], false);
    end;    
    
    self.numbrakelights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.brakelights#count"), 0);
    self.brakelights = {};
    for i=1, self.numbrakelights do
        local brakelightnamei = string.format("vehicle.brakelights.brakelight" .. "%d", i);
        self.brakelights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, brakelightnamei .. "#index"));
        setVisibility(self.brakelights[i], false);
    end;
    self.brakelightsActive = false;
    self.braking = false;
    
    local radioSound = getXMLString(xmlFile, "vehicle.radioSound#file");
    if  radioSound ~= nil and  radioSound ~= "" then
        radioSound = Utils.getFilename( radioSound, self.baseDirectory); 
        self.radioSound = createSample(" radioSound");
        self.radioSoundPlaying = false;
        loadSample(self. radioSound, radioSound, false);
        self.radioSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.radioSound#volume"),1);
    end;
    local brakeSound = getXMLString(xmlFile, "vehicle.brakeSound#file");
    if brakeSound ~= nil and brakeSound ~= "" then
    brakeSound = Utils.getFilename(brakeSound, self.baseDirectory);
        self.brakeSound = createSample("brakeSound");
        loadSample(self.brakeSound, brakeSound, false);
    end;
    
    local handbrakeSound = getXMLString(xmlFile, "vehicle.handbrakeSound#file");
    if handbrakeSound ~= nil and handbrakeSound ~= "" then
    handbrakeSound = Utils.getFilename(handbrakeSound, self.baseDirectory);
        self.handbrakeSound = createSample("handbrakeSound");
        loadSample(self.handbrakeSound, handbrakeSound, false);
    end;
    local handbrakeReleaseSound = getXMLString(xmlFile, "vehicle.handbrakeReleaseSound#file");
    if handbrakeReleaseSound ~= nil and handbrakeReleaseSound ~= "" then
    handbrakeReleaseSound = Utils.getFilename(handbrakeReleaseSound, self.baseDirectory);
        self.handbrakeReleaseSound = createSample("handbrakeReleaseSound");
        loadSample(self.handbrakeReleaseSound, handbrakeReleaseSound, false);
    end;
    
    local compressorSound = getXMLString(xmlFile, "vehicle.compressorSound#file");
    if compressorSound ~= nil and compressorSound ~= "" then
    compressorSound = Utils.getFilename(compressorSound, self.baseDirectory);
        self.compressorSound = createSample("compressorSound");
        loadSample(self.compressorSound, compressorSound, false);
    end;
    
    local compressorStopSound = getXMLString(xmlFile, "vehicle.compressorStopSound#file");
    if compressorStopSound ~= nil and compressorStopSound ~= "" then
    compressorStopSound = Utils.getFilename(compressorStopSound, self.baseDirectory);
        self.compressorStopSound = createSample("compressorStopSound");
        loadSample(self.compressorStopSound, compressorStopSound, false);
    end;
    
    self.rundumleuchtenAnz = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.rundumleuchten#count"),0);
    self.rundumleuchtenAn = false;
    self.rundumleuchten = {};
    for i=1, self.rundumleuchtenAnz do
        local objname = string.format("vehicle.rundumleuchten.light" .. "%d",i);
        self.rundumleuchten[i] = {};
        self.rundumleuchten[i].rotNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#rotNode"));
        self.rundumleuchten[i].light = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#light"));
        self.rundumleuchten[i].source = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#lightsource"));
        self.rundumleuchten[i].speed = Utils.getNoNil(getXMLInt(xmlFile,  objname .. "#rotSpeed"), 1)/1000;
        self.rundumleuchten[i].emit = Utils.getNoNil(getXMLBool(xmlFile, objname .. "#emitLight"), true);
        if not self.rundumleuchten[i].emit and self.rundumleuchten[i].source ~= nil then
           setVisibility(self.rundumleuchten[i].source, false);
        end;
    end;
    
    self.numFrontlights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.frontlights#count"), 0);
    self.frontlights = {};
    for i=1, self.numFrontlights do
        local frontlightnamei = string.format("vehicle.frontlights.frontlight" .. "%d", i);
        self.frontlights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, frontlightnamei .. "#index"));
        setVisibility(self.frontlights[i], false);
    end;    
 

     self.numFarlights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.farlights#count"), 0);
    self.farlights = {};
    for i=1, self.numFarlights do
        local farlightnamei = string.format("vehicle.farlights.farlight" .. "%d", i);
        self.farlights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, farlightnamei .. "#index"));
        setVisibility(self.farlights[i], false);
    end;    
   
    local rotationPartNodeWischer = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartWischer#index"));
    if rotationPartNodeWischer ~= nil then
        self.rotationPartWischer = {};
        self.rotationPartWischer.node = rotationPartNodeWischer;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartWischer#minRot"));
        self.rotationPartWischer.minRot = {};
        self.rotationPartWischer.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartWischer.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartWischer.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartWischer#maxRot"));
        self.rotationPartWischer.maxRot = {};
        self.rotationPartWischer.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartWischer.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartWischer.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartWischer.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartWischer#rotTime"), 2)*1000;
        self.rotationPartWischer.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartWischer#touchRotLimit"), 10));
    end;
    
    local rotationPartNodeWischerblatt = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartWischerblatt#index"));
    if rotationPartNodeWischerblatt ~= nil then
        self.rotationPartWischerblatt = {};
        self.rotationPartWischerblatt.node = rotationPartNodeWischerblatt;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartWischerblatt#minRot"));
        self.rotationPartWischerblatt.minRot = {};
        self.rotationPartWischerblatt.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartWischerblatt.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartWischerblatt.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartWischerblatt#maxRot"));
        self.rotationPartWischerblatt.maxRot = {};
        self.rotationPartWischerblatt.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartWischerblatt.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartWischerblatt.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartWischerblatt.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartWischerblatt#rotTime"), 2)*1000;
        self.rotationPartWischerblatt.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartWischerblatt#touchRotLimit"), 10));
    end;
    local rotationPartNodeDruck = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartDruck#index"));
    if rotationPartNodeDruck ~= nil then
        self.rotationPartDruck = {};
        self.rotationPartDruck.node = rotationPartNodeDruck;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDruck#minRot"));
        self.rotationPartDruck.minRot = {};
        self.rotationPartDruck.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDruck.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDruck.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDruck#maxRot"));
        self.rotationPartDruck.maxRot = {};
        self.rotationPartDruck.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDruck.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDruck.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartDruck.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDruck#rotTime"), 2)*1000;
        self.rotationPartDruck.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDruck#touchRotLimit"), 10));
    end;
    
    local rotationPartNodeDruckLight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartDruckLight#index"));
    if rotationPartNodeDruckLight ~= nil then
        self.rotationPartDruckLight = {};
        self.rotationPartDruckLight.node = rotationPartNodeDruckLight;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDruckLight#minRot"));
        self.rotationPartDruckLight.minRot = {};
        self.rotationPartDruckLight.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDruckLight.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDruckLight.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDruckLight#maxRot"));
        self.rotationPartDruckLight.maxRot = {};
        self.rotationPartDruckLight.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDruckLight.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDruckLight.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartDruckLight.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDruckLight#rotTime"), 2)*1000;
        self.rotationPartDruckLight.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDruckLight#touchRotLimit"), 10));
    end;
    
    local rotationPartNodebackwindow = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.backwindow#index"));
    if rotationPartNodebackwindow ~= nil then
        self.rotationPartbackwindow = {};
        self.rotationPartbackwindow.node = rotationPartNodebackwindow;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartbackwindow#minRot"));
        self.rotationPartbackwindow.minRot = {};
        self.rotationPartbackwindow.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartbackwindow.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartbackwindow.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.backwindow#maxRot"));
        self.rotationPartbackwindow.maxRot = {};
        self.rotationPartbackwindow.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartbackwindow.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartbackwindow.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartbackwindow.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.backwindow#rotTime"), 2)*1000;
        self.rotationPartbackwindow.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.backwindow#touchRotLimit"), 10));
    end;
    
    local rotationNode11 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation11#index"));
        self.rotation11 = {};
          self.rotation11.node = rotationNode11;

    local rotationNode12 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation12#index"));
        self.rotation12 = {};
          self.rotation12.node = rotationNode12;
          
    self.moddir= self.baseDirectory;
    hornSoundFile = Utils.getFilename("sound/hornBig.wav", self.moddir);
    self.hornSoundId = createSample("HupenSound");
    loadSample(self.hornSoundId, hornSoundFile, false);
    
    self.exhaustParticleLow = {};
    Utils.loadParticleSystem(xmlFile, self.exhaustParticleLow, "vehicle.exhaustParticleLow", self.rootNode, false, nil, self.baseDirectory);
    self.exhaustParticleHigh = {};
    Utils.loadParticleSystem(xmlFile, self.exhaustParticleHigh, "vehicle.exhaustParticleHigh", self.rootNode, false, nil, self.baseDirectory);

    local motorMaxRpmStr = getXMLString(xmlFile, "vehicle.motor#maxRpm");
    local motorMaxRpm1, motorMaxRpm2, motorMaxRpm3 = Utils.getVectorFromString(motorMaxRpmStr);
    motorMaxRpm1 = Utils.getNoNil(motorMaxRpm1, 800);
    motorMaxRpm2 = Utils.getNoNil(motorMaxRpm2, 1000);
    motorMaxRpm3 = Utils.getNoNil(motorMaxRpm3, 1500);
    local motorMaxRpm = {motorMaxRpm1, motorMaxRpm2, motorMaxRpm3};
    self.motorMaxRpmLimit = motorMaxRpm;
    self.rotacaomaximaportaesquerda = false;
    self.duelWheelsActive = false;
    --[[Blinker start]]-----    
    
    self.numTurnlights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.turnlights#count"), 0);
    self.turnlights = {};
    for i=1, self.numTurnlights do
        local turnlightnamei = string.format("vehicle.turnlights.turnlight" .. "%d", i);
        self.turnlights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, turnlightnamei .. "#index"));
        setVisibility(self.turnlights[i], false);
    end;    
--[[Blinker ende]]------------------------------------------------------------    

    self.keys = {};
    local i=0;
    while true do
        local baseName = string.format("vehicle.keys.input(%d)", i);
        local inputName = getXMLString(xmlFile, baseName.. "#name");
        if inputName == nil then
            break;
        end;
        local inputKey = getXMLString(xmlFile, baseName.. "#key");
        if Input[inputKey] == nil then
            print("Error: invalid key '" .. inputKey .. "'  for input event '" .. inputName .. "'");
            break;
        end;
        self.keys[inputName] = Input[inputKey];
        i = i+1;
    end;
    
    
    self.brakeOn = false;
    self.lightsbrake = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.extra_lights.brake#index"));
    self.druckl_green = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.extra_lights.druckl_green#index"));
    self.druckl_red = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.extra_lights.druckl_red#index"));
    self.lightsfuelwarn = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.extra_lights.fuelwarn#index"));
    self.lightshandbrake = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.extra_lights.handbrake#index"));
    self.lightsradio = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.extra_lights.radio#index"));
    self.frontlights.outs = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.frontlights.frontlight#src"));
    self.handbrakeSoundRunning = false;
    self.handbrakeReleaseSoundRunning = false;
    self.brakeForce = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.brakeForce"), 10);
    self.motorBrakeForce = self.motor.brakeForce;
    self.druckLevel = 6500;
    self.farlightsActive = false;
    self.frontlightsActive = false;
    self.worklightsActive = false;
    self.hornPlaying = false;
    self.zuendungKey = true;
    self.allowedZuendung = true; 
    self.compressorStart = false;
    self.brakeSoundRunning = true;
    self.rotationMaxbackwindow = false;
    self.revLimit = 100;
    self.delayWischer1 = 0;
    self.delayWischer2 = 0;
    self.compressor = false;
    self.handbrake = true;

end;

function Tatra:keyEvent(unicode, sym, modifier, isDown)

    if isDown and sym == Input.KEY_home then
      self.rundumleuchtenAn = not self.rundumleuchtenAn;
      for i=1, self.rundumleuchtenAnz do
        setVisibility(self.rundumleuchten[i].light, self.rundumleuchtenAn);
      end;
    end;
    if isDown and sym == Input.KEY_space and self.spec_HB == nil then
        self.handbrake = not self.handbrake;
    end;
    if isDown and sym == Input.KEY_z then
        self.helpPanel = not self.helpPanel;
    end;
     if isDown and sym == Input.KEY_f then
        self.lightsActive = not self.lightsActive;
    end;
    if isDown and sym == Input.KEY_KP_5 then
        self.farlightsActive = not self.farlightsActive;
        self:setState("highbeam", self.farlightsActive);
    end;    
end;


function Tatra:update(dt)

    if self.isEntered and not (self.isHired or self.drive) then
        if self.rotationPartbackwindow ~= nil then
           local x, y, z = getRotation(self.rotationPartbackwindow.node);
           local rot = {x,y,z};
           local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartbackwindow.maxRot, self.rotationPartbackwindow.minRot, 3, self.rotationPartbackwindow.rotTime, dt, not self.rotationMaxbackwindow);
           setRotation(self.rotationPartbackwindow.node, unpack(newRot));
        end;

        if self.isEntered then
            if self.worklightsActive then
                for i=1, self.numWorklights do
                    local worklight = self.worklights[i];
                    setVisibility(worklight, self.worklightsActive);
                end;
            else
                for i=1, self.numWorklights do
                    local worklight = self.worklights[i];
                    setVisibility(worklight, self.worklightsActive, false);
                end;
            end;
        end;
        
        if self.isEntered then
            if self.frontlightsActive then
                for i=1, self.numFrontlights do
                    local frontlight = self.frontlights[i];
                    setVisibility(frontlight, self.frontlightsActive);
                end;
            else
                for i=1, self.numFrontlights do
                    local frontlight = self.frontlights[i];
                    setVisibility(frontlight, self.frontlightsActive, false);
                    setVisibility(self.frontlights.outs, true);
                end;
            end;
        end; 
    end;
    
    if self.isEntered and not (self.isHired or self.drive) then
        if self.farlightsActive and self.farlightsActive ~= nil then
           for i=1, self.numFarlights do
                local farlight = self.farlights[i];
                setVisibility(farlight, self.farlightsActive);
            end;
        else 
            if not self.farlightsActive then
                for i=1, self.numFarlights do
                    local farlight = self.farlights[i];
                    setVisibility(farlight, self.farlightsActive, false);
                end;
            end;
        end;
        if self:getIsActiveForInput() and self:getIsActiveForSound() and Input.keyPressedState[114] then
            if not self.radioSoundPlaying then 
               playSample(self. radioSound, 0, self. radioSoundVolume, 0); 
               self.radioSoundPlaying = true; 
               setVisibility(self.lightsradio, true);
            else 
                stopSample(self. radioSound); 
                self.radioSoundPlaying = false; 
                setVisibility(self.lightsradio, false);
            end;  
        end;
        if self.isEntered and self.isEntered ~= nil then
          if self.frontlightsActive then
            setVisibility(self.frontlights.outs, false);
          else
            setVisibility(self.frontlights.outs, true);
          end;
        end;

        inputAxisY = InputBinding.getAnalogInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE);
        if InputBinding.isAxisZero(inputAxisY) then
        inputAxisY = InputBinding.getDigitalInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE);
        end;

        if self:getIsActiveForInput() and self:getIsActiveForSound() and Input.keyPressedState[48] then
            if not self.hornPlaying then
                playSample(self.hornSoundId, 0, 1, 0);
                self.hornPlaying = true;
            end;
        else
            if self.hornPlaying then
                stopSample(self.hornSoundId);
                self.hornPlaying = false;
            end;
        end;

        if self.rundumleuchtenAn then
          for i=1, self.rundumleuchtenAnz do
            rotate(self.rundumleuchten[i].rotNode, 0, dt*self.rundumleuchten[i].speed, 0);
          end;
        end;
        
        if g_currentMission.environment ~= nil and g_currentMission.environment.dayNightCycle and
              (g_currentMission.environment.dayTime > (20.5*1000*60*60) or g_currentMission.environment.dayTime < (5.5*1000*60*60)) and
              not self.lightsActive and (self.isHired or self.drive) and not self.steeringEnabled then
        self.lightsActive = true;
    end;

    for k, light in pairs(self.lights) do
        setVisibility(light, self.lightsActive);
    end; 
    

   if not self.isAITractorActivated and self.isAITractorActivated ~= nil then

        if self:getIsActiveForInput() then
            if Input.keyPressedState[271] then
                self.zuendungKey = not self.zuendungKey;
                self.allowedZuendung = true;
            end;
        end;
        
        if not self.allowedZuendung and  not self.zuendungKey then
            self.isMotorStarted = true;
            Motorized.stopSounds(self);
            self.steeringEnabled = false;
            Utils.setEmittingState(self.exhaustParticleSystems, false)
        end;
        
        
        if self.allowedZuendung then
            if  not self.zuendungKey then
                self.motorStopSoundVolume = self.motorStopSoundVolume2;
                self:stopMotor();
                self.steeringEnabled = false;
                self.allowedZuendung = true;    
                setVisibility(self.druckl_red, false);
                setVisibility(self.druckl_green, false);    
                self.compressor = false ;
                for k,wheel in pairs(self.wheels) do
                    setWheelShapeProps(wheel.node, wheel.wheelShape, 0, self.motor.brakeForce, 0);
                end;
                self:onDeactivateAttachements();
            elseif self.zuendungKey then
                self.steeringEnabled = true;
                self.allowedZuendung = true;
                setVisibility(self.druckl_red, true);
                setVisibility(self.druckl_green, true);    
                self.compressor = true ;
               end;
        end;
   
    elseif not self.zuendungKey and not self.deactivateOnLeave then
        self:stopAITractor();
    end;

  end;

    if self.isMotorStarted and self:getIsActiveForInput() and self.isEntered then
    
        if self.motor.speedLevel ~= 0 then
            
            if Input.keyPressedState[119] then 
                if self.motor.maxRpm[self.motor.speedLevel] <= (self.motorMaxRpmLimit[3] - 10) then
                    self.motor.maxRpm[self.motor.speedLevel] = self.motor.maxRpm[self.motor.speedLevel] + 10;
                end;
            elseif Input.keyPressedState[115] then
                if self.motor.maxRpm[self.motor.speedLevel] >= 10 then
                    self.motor.maxRpm[self.motor.speedLevel] = self.motor.maxRpm[self.motor.speedLevel] - 10;
                end;
            end;
                
        else
            if Input.keyPressedState[119] then
                if self.motor.maxRpm[3] <= (self.motorMaxRpmLimit[3] - 10) then
                    self.motor.maxRpm[3] = self.motor.maxRpm[3] + 10;
                end;
            elseif Input.keyPressedState[115] then
                if self.motor.maxRpm[3] >= 10 then
                        self.motor.maxRpm[3] = self.motor.maxRpm[3] - 10;
                end;
            end;
        end;
        
    end;

  if self.compressor and not (self.isHired or self.drive) then 
      if self.druckLevel >= -1 and self.druckLevel <= 6000 then
            self.compressorStart = true;
        end;
        if self.druckLevel >= 9999 then
            self.compressorStart = false;
        end;
        if self.compressorStart == true then
            if not self.compressorSoundRunning then
                playSample(self.compressorSound, 0, 1, 0);
                self.compressorSoundRunning = true;
            end;
            self.compressorStopSoundRunning = false;
            if self.druckLevel <= 10000 then
                self.druckLevel = self.druckLevel +(dt/3);
            end;
        end;
        if self.compressorStart == false then
            stopSample(self.compressorSound, 0, 1, 0);
            self.compressorSoundRunning = false;
            if not self.compressorStopSoundRunning then
                playSample(self.compressorStopSound, 1, 1, 0);
                self.compressorStopSoundRunning = true;
            end;

        end;
        if self.compressor then
        if self.druckLevel <= 6100 then
            self.druckWarning = true;
           setVisibility(self.druckl_red, true);
        else
            self.druckWarning = false;
            self.druckWarnlightsActive = false;
           setVisibility(self.druckl_red, false);            
        end;
        if self.druckLevel >= 6000 then
            self.drucklightsActive = true;
           setVisibility(self.druckl_green, true);            
        else
            self.drucklightsActive = false;
           setVisibility(self.druckl_green, false);    
        end;
     end;
     
     
     local maxDruck = 10000;
    if self.rotationPartDruck ~= nil then
        local x, y, z = getRotation(self.rotationPartDruck.node);
        y = ((self.rotationPartDruck.maxRot[2] - self.rotationPartDruck.minRot[2]) / maxDruck) * self.druckLevel + self.rotationPartDruck.minRot[2];
        setRotation(self.rotationPartDruck.node, x, y ,z);
    end;
    
    local maxDruckLight = 10000;
    if self.rotationPartDruckLight ~= nil then
        local x, y, z = getRotation(self.rotationPartDruckLight.node);
        y = ((self.rotationPartDruckLight.maxRot[2] - self.rotationPartDruckLight.minRot[2]) / maxDruckLight) * self.druckLevel + self.rotationPartDruckLight.minRot[2];
        setRotation(self.rotationPartDruckLight.node, x, y ,z);
    end;
    
       
        local fuelWarn = 75;
        if self.fuelFillLevel < fuelWarn then
           setVisibility(self.lightsfuelwarn, true);
        else
           setVisibility(self.lightsfuelwarn, false);
        end;
        
        inputAxisY = InputBinding.getAnalogInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE);
        if InputBinding.isAxisZero(inputAxisY) then
            inputAxisY = InputBinding.getDigitalInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE);
        end;        
        
        if self.isEntered then
        if (self.movingDirection*self.lastSpeed*(-inputAxisY)) < -0.001 then
            setVisibility(self.lightsbrake, true);
            if self.druckLevel >= 5500 then
                self.motor.brakeForce = self.motorBrakeForce;
                if not self.brakeSoundRunning then
                    playSample(self.brakeSound, 1, 1, 0);
                    self.brakeSoundRunning = true;
                end;
            end;
            if not self.braking then
                if self.druckLevel > 0 then
                    self.druckLevel = self.druckLevel -350;
                end;
                self.braking = true;
            end;
        else
            if not self.handbrake then
                self.motor.brakeForce = self.motor.brakeForce*0;
            end;
                setVisibility(self.lightsbrake, false);
            self.braking = false;
            if self.druckLevel >= 5500 then
        
                    self.brakeSoundRunning = false;
            end;
        end;


        if g_currentMission.attachableInMountRange ~= nil then
            self.motor.brakeForce = self.brakeForce;
        end;

    
        if self.handbrake then
            brakeTorque = 10000;
            self.motor.brakeForce = brakeTorque;
            self.braking = true;
            setVisibility(self.lightshandbrake, self.handbrake);


            if not self.handbrakeSoundRunning then
                playSample(self.handbrakeSound, 1, 1, 0);
                self.handbrakeSoundRunning = true;
            end;
            self.handbrakeReleaseSoundRunning = false;
        else
            if not self.handbrakeReleaseSoundRunning and not self.handbrake then
                playSample(self.handbrakeReleaseSound, 1, 1, 0);
                self.handbrakeReleaseSoundRunning = true;
            end;
            setVisibility(self.lightshandbrake, false);
            self.handbrakeSoundRunning = false;
        end;
    end;
 end;

 if self.isEntered and self.isEntered ~= nil and g_currentMission.environment.lastRainScale ~= nil and not (self.isHired or self.drive) then
    
        if g_currentMission.environment.lastRainScale <= 0.1 and g_currentMission.environment.timeSinceLastRain > 30 then
            self.rainWarning = false;
        else
            self.rainWarning = true;
        end;
        
        if self.rainWarning and self.isMotorStarted then
            if self.delayWischer1 >= 0 then
                self.delayWischer1 = self.delayWischer1 -dt;
            end;
            if self.delayWischer2 >= 0 then
                self.delayWischer2 = self.delayWischer2 -dt;
            end;
            if not self.rotationMaxWischer then
                if self.delayWischer1 < 0 then
                    self.delayWischer2 = 1000;
                    self.rotationMaxWischer = true;
                    self.rotationMaxWischerblatt = true;
                end;
            end;
            if self.rotationMaxWischer then
                if self.delayWischer2 < 0 then
                    self.delayWischer1 = 1000;
                    self.rotationMaxWischer = false;
                    self.rotationMaxWischerblatt = false;
                end;
            end;
        else
            self.rotationMaxWischer = false;
            self.rotationMaxWischerblatt = false;
        end;
    end;

      if self.rotationPartWischer ~= nil then
        local x, y, z = getRotation(self.rotationPartWischer.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartWischer.maxRot, self.rotationPartWischer.minRot, 3, self.rotationPartWischer.rotTime, dt, not self.rotationMaxWischer);
        setRotation(self.rotationPartWischer.node, unpack(newRot));
    end;  
    if self.rotationPartWischerblatt ~= nil then
        local x, y, z = getRotation(self.rotationPartWischerblatt.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartWischerblatt.maxRot, self.rotationPartWischerblatt.minRot, 3, self.rotationPartWischerblatt.rotTime, dt, not self.rotationMaxWischerblatt);
        setRotation(self.rotationPartWischerblatt.node, unpack(newRot));
    end;
    

    if self.isMotorStarted then
        if self.motor.lastMotorRpm > 200 and self.motor.lastMotorRpm < 1200 then
            Utils.setEmittingState(self.exhaustParticleLow, true);
            Utils.setEmittingState(self.exhaustParticleHigh, false);
        else
            Utils.setEmittingState(self.exhaustParticleLow, false);
            Utils.setEmittingState(self.exhaustParticleHigh, true);            
        end;
        if self.motor.lastMotorRpm > 1300 then
            Utils.setEmittingState(self.exhaustParticleLow, false);
            Utils.setEmittingState(self.exhaustParticleHigh, true);         
        else
            Utils.setEmittingState(self.exhaustParticleLow, true);
            Utils.setEmittingState(self.exhaustParticleHigh, false); 
        end;
    else 
        Utils.setEmittingState(self.exhaustParticleLow, false);
        Utils.setEmittingState(self.exhaustParticleHigh, false); 
    end;
end;

function Tatra:draw()

    if self.isEntered then

        local vPosX = 0.632;
        local vPosY = 0.984;
        local vLine = 1;
        local vValX = vPosX + 0.1
        local vFontSize = 0.018;
        local vLineDist = vFontSize + 0.0014;
        if not self.helpPanel then
            renderText(vPosX - vFontSize , vPosY, 0.014, "Z: NL12 - Zobrazit  manual");
        else
            renderText(vPosX - vFontSize , vPosY, 0.014, "Z: NL12 - Zobrazit  manual");
        end;
        if self.helpPanel then
            renderText(vPosX, vPosY-(vLine*vLineDist), 0.02, "Volvo NL12 6x2");
            vLine = vLine + 1;
            renderText(vPosX, vPosY-(vLine*vLineDist), vFontSize, "Start motoru");renderText(vValX,vPosY-(vLine*vLineDist), vFontSize, "y");
            vLine = vLine + 1;
            renderText(vPosX, vPosY-(vLine*vLineDist), vFontSize, "Leva smerovka");renderText(vValX,vPosY-(vLine*vLineDist), vFontSize,"Numeric 1");
            vLine = vLine + 1;
            renderText(vPosX, vPosY-(vLine*vLineDist), vFontSize,         "Varovni blinkry");renderText(vValX,vPosY-(vLine*vLineDist), vFontSize, "Numeric 2");
            vLine = vLine + 1;
            renderText(vPosX, vPosY-(vLine*vLineDist), vFontSize,         "Prava smerovka");renderText(vValX,vPosY-(vLine*vLineDist), vFontSize, "Numeric 3");
            vLine = vLine + 1;
            renderText(vPosX, vPosY-(vLine*vLineDist), vFontSize,         "Osvetleni kabiny");renderText(vValX,vPosY-(vLine*vLineDist), vFontSize,"Numeric 4");
            vLine = vLine + 1;
            renderText(vPosX, vPosY-(vLine*vLineDist), vFontSize,         "Mlhovky zap/vyp");renderText(vValX,vPosY-(vLine*vLineDist), vFontSize, "Numeric 5");
            vLine = vLine + 1;
            renderText(vPosX, vPosY-(vLine*vLineDist), vFontSize,        "Zadni svetlo");renderText(vValX,vPosY-(vLine*vLineDist), vFontSize, "Numeric 6");
            vLine = vLine + 1;
            renderText(vPosX, vPosY-(vLine*vLineDist), vFontSize,         "Leve dvere");renderText(vValX,vPosY-(vLine*vLineDist), vFontSize, "Numeric 7");    
            vLine = vLine + 1;
            renderText(vPosX, vPosY-(vLine*vLineDist), vFontSize,         "Prave dvere");renderText(vValX,vPosY-(vLine*vLineDist), vFontSize, "Numeric 8");
            vLine = vLine + 1;
            renderText(vPosX, vPosY-(vLine*vLineDist), vFontSize,         "Svetla");renderText(vValX,vPosY-(vLine*vLineDist), vFontSize, "F");
            vLine = vLine + 1;
            renderText(vPosX, vPosY-(vLine*vLineDist), vFontSize,         "Rucni brzda");renderText(vValX,vPosY-(vLine*vLineDist), vFontSize, "mezernik");
            vLine = vLine + 1;
            renderText(vPosX, vPosY-(vLine*vLineDist), vFontSize,         "Zadni kola");renderText(vValX,vPosY-(vLine*vLineDist), vFontSize, "V");
            vLine = vLine + 1;
            renderText(vPosX, vPosY-(vLine*vLineDist), vFontSize,         "Sterace");renderText(vValX,vPosY-(vLine*vLineDist), vFontSize, "7");
            vLine = vLine + 1;
            renderText(vPosX, vPosY-(vLine*vLineDist), vFontSize,         "Zpetne zrcadla");renderText(vValX,vPosY-(vLine*vLineDist), vFontSize, "8");
            vLine = vLine + 1;
            renderText(vPosX, vPosY-(vLine*vLineDist), vFontSize,         "Ozdoby kol");renderText(vValX,vPosY-(vLine*vLineDist), vFontSize, "9");
        end;
    end;
    if self.handbrake and self.spec_HB == nil then
        setTextBold(true);
        setTextColor(1,0,0,1);
        inputAxisY = InputBinding.getAnalogInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE);
        if InputBinding.isAxisZero(inputAxisY) then
            inputAxisY = InputBinding.getDigitalInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE);
        end;        
        if (self.movingDirection*self.lastSpeed*(-inputAxisY))  then
            setTextBold(true);
            setTextColor(1,0,0,1);
            if self.isServer then
                for k,wheel in pairs(self.wheels) do
                    setWheelShapeProps(wheel.node, wheel.wheelShape, 0, 999, 0);
                end;
            end;            
        end;
        self.handBrakeHud:render();
        setTextColor(1,1,1,1);
    end;
end;

function Tatra:onEnter()
    self.compressorStopSoundRunning = true;
    Utils.setEmittingState(self.exhaustParticleLow, false);
end;

function Tatra:onLeave()
    self.rundumleuchtenAn = false;
    for i=1, self.rundumleuchtenAnz do
       setVisibility(self.rundumleuchten[i].light, self.rundumleuchtenAn);
    end;
    self.worklightsActive = false;
    
    if self.radioSound ~= nil then
        stopSample(self.radioSound);
    end;
    
    if not self.deactivateOnLeave then
        self.allowedZuendung = false;
        self.zuendungKey = true; 
    else
        self.allowedZuendung = true;
        self.zuendungKey = true;
    end;
     Utils.setEmittingState(self.exhaustParticleLow, false);
     stopSample(self.compressorSound);
     self.compressorSoundRunning = false;
end;

function Tatra:delete()
    Utils.deleteParticleSystem(self.exhaustParticleLow);
    Utils.deleteParticleSystem(self.exhaustParticleHigh);
    delete(self.hornSoundId);
    stopSample(self.compressorSound);
    delete(self.radioSound)
    print("Volvo N12 Tatra unloaded");
end;


function Tatra:mouseEvent(posX, posY, isDown, isUp, button)
end;

function key_convert(key)
    if key ~= nil then 
        local keyname = "";
        if key > 32 and key < 123 then
            keyname = string.upper(string.char(key));
        elseif key > 255 and key < 266 then
            keyname = "NUM "..string.char(key-208);
        else 
            keyname = "";
        end;
        return(keyname);
      end;
end;
